<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Order1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Order1 extends AbstractStructArrayBase
{
    /**
     * The ChildA
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Order[]
     */
    public $ChildA;
    /**
     * Constructor method for ArrayOfJPSOAP_Order1
     * @uses ArrayOfJPSOAP_Order1::setChildA()
     * @param \StructType\JPSOAP_Order[] $childA
     */
    public function __construct(array $childA = array())
    {
        $this
            ->setChildA($childA);
    }
    /**
     * Get ChildA value
     * @return \StructType\JPSOAP_Order[]|null
     */
    public function getChildA()
    {
        return $this->ChildA;
    }
    /**
     * This method is responsible for validating the values passed to the setChildA method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChildA method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChildAForArrayConstraintsFromSetChildA(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_Order1ChildAItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_Order1ChildAItem instanceof \StructType\JPSOAP_Order) {
                $invalidValues[] = is_object($arrayOfJPSOAP_Order1ChildAItem) ? get_class($arrayOfJPSOAP_Order1ChildAItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_Order1ChildAItem), var_export($arrayOfJPSOAP_Order1ChildAItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChildA property can only contain items of type \StructType\JPSOAP_Order, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChildA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Order[] $childA
     * @return \ArrayType\ArrayOfJPSOAP_Order1
     */
    public function setChildA(array $childA = array())
    {
        // validation for constraint: array
        if ('' !== ($childAArrayErrorMessage = self::validateChildAForArrayConstraintsFromSetChildA($childA))) {
            throw new \InvalidArgumentException($childAArrayErrorMessage, __LINE__);
        }
        $this->ChildA = $childA;
        return $this;
    }
    /**
     * Add item to ChildA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Order $item
     * @return \ArrayType\ArrayOfJPSOAP_Order1
     */
    public function addToChildA(\StructType\JPSOAP_Order $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Order) {
            throw new \InvalidArgumentException(sprintf('The ChildA property can only contain items of type \StructType\JPSOAP_Order, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChildA[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Order|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Order|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Order|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Order|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Order|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildA
     */
    public function getAttributeName()
    {
        return 'ChildA';
    }
}
